//
//  XFluidViscosity.swift
//
//
//  Created by Michiel Carman on 1/31/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlXFluidViscosity: Model, Content {
    static let schema = "xFluidViscosity"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    @Parent(key: "fluidId") var fluid: mdlFluid
    @Parent(key: "viscosityId") var viscosity: mdlViscosity
    @Field(key: "sortOrder") var sortorder: Int?
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init(){}
    
    init(id: Int? = nil, fluidid: Int, viscosityid: Int, sortorder: Int? = nil, createdate: Date? = nil, createuserid: Int? = nil, updatedate: Date? = nil, updateuserid: Int? = nil) {
        self.id = id
        self.fluid.$id.value = fluidid
        self.viscosity.$id.value = viscosityid
        self.sortorder = sortorder
        self.createdate = createdate
        self.createuserid = createuserid
        self.updatedate = updatedate
        self.updateuserid = updateuserid
    }
    
}
extension mdlXFluidViscosity{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("xFluidViscosity")
                .field("id", .int, .identifier(auto: true))
                .field("userId", .int, .references("user", "id"))
                .field("roleid", .int, .references("role", "id"))
                .field("sortOrder", .int)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("user").delete()
        }
    }
    struct Mod1: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("xFluidViscosity")
                .deleteField("roleid")
                .deleteField("userId")
                .field("fluidId", .int, .references("fluid", "id"))
                .field("viscosityId", .int, .references("viscosity", "id"))
                .update()
        }

        func revert(on database: Database) async throws {
            try await database.schema("user")
                .deleteField("fluidId")
                .deleteField("viscosityId")
                .field("roleid", .int, .references("role", "id"))
                .field("userId", .int, .references("user", "id"))
                .update()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlXFluidViscosity>{
        
        let query = mdlXFluidViscosity.query(on: req.db)
            .with(\.$fluid)
            .with(\.$viscosity)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}




